unit global;

interface
const
  CS_SUCCEED            = 1;
  CS_FAIL               = 0;
  CS_MEM_ERROR          = -1;
  CS_PENDING            = -2;
  CS_QUIET              = -3;
  CS_BUSY               = -4;
  CS_INTERRUPT          = -5;
  CS_CONTINUE           = -7;
  CS_FATAL              = -8;

  CS_NULLTERM           = (-9);
  CS_WILDCARD           = (-99);
  CS_NO_LIMIT           = (-9999);
  CS_UNUSED             = (-99999);
  CS_UNEXPIRED          = (-999999);

  CS_ILLEGAL_TYPE       = (-1);
  CS_CHAR_TYPE          = 0;
  CS_BINARY_TYPE        = 1;
  CS_LONGCHAR_TYPE      = 2;
  CS_LONGBINARY_TYPE    = 3;
  CS_TEXT_TYPE          = 4;
  CS_IMAGE_TYPE         = 5;
  CS_TINYINT_TYPE       = 6;
  CS_SMALLINT_TYPE      = 7;
  CS_INT_TYPE           = 8;
  CS_REAL_TYPE          = 9;
  CS_FLOAT_TYPE         = 10;
  CS_BIT_TYPE           = 11;
  CS_DATETIME_TYPE      = 12;
  CS_DATETIME4_TYPE     = 13;
  CS_MONEY_TYPE         = 14;
  CS_MONEY4_TYPE        = 15;
  CS_NUMERIC_TYPE       = 16;
  CS_DECIMAL_TYPE       = 17;
  CS_VARCHAR_TYPE       = 18;
  CS_VARBINARY_TYPE     = 19;
  CS_LONG_TYPE          = 20;
  CS_SENSITIVITY_TYPE   = 21;
  CS_BOUNDARY_TYPE      = 22;
  CS_VOID_TYPE          = 23;
  CS_USHORT_TYPE        = 24;

  CS_TRUE               = 1;
  CS_FALSE              = 0;

  CS_MAX_NAME           = (128 + 4);
  CS_MAX_PASS           = (30);
  CS_MAX_CHAR           = 256;
  
  CS_MIN_PREC           = 1;
  CS_MAX_PREC           = 77;
  CS_DEF_PREC           = 18;
  CS_MIN_SCALE          = 0;
  CS_MAX_SCALE          = 77;
  CS_DEF_SCALE          = 0;

  CS_FMT_UNUSED         = $0;
  CS_FMT_NULLTERM       = $1;
  CS_FMT_PADNULL        = $2;
  CS_FMT_PADBLANK       = $4;
  CS_FMT_JUSTIFY_RT     = $8;
  CS_FMT_STRIPBLANKS    = $10;
  CS_FMT_SAFESTR        = $20;

  CS_MAX_MSG            = 1024;

  CS_TS_SIZE            = 8;
  CS_TP_SIZE            = 16;
  CS_SQLSTATE_SIZE      = 8;
  CS_VERSION_100        = 112;
  CS_VERSION_110        = 1100;

  CS_GET                = 33;
  CS_SET                = 34;
  CS_CLEAR              = 35;
  CS_INIT               = 36;
  CS_STATUS             = 37;

  CS_LOGIN_STATUS       = 9104;
  CS_NUMDATA            = 803;

  CS_EXTERNAL_ERR       = (-200);
  CS_INTERNAL_ERR       = (-300);

  CS_CMD_FAIL           = 4048;
  CS_ROWFMT_RESULT      = 4049;
  CS_COMPUTEFMT_RESULT  = 4050;
  CS_DESCRIBE_RESULT    = 4051;
  CS_ROW_COUNT          = 800;
  CS_CMD_NUMBER         = 801;
  CS_NUM_COMPUTES       = 802;
  CS_ORDERBY_COLS       = 804;
  CS_NUMORDERCOLS       = 805;
  CS_MSGTYPE            = 806;

  CS_ROW_FAIL           = (CS_EXTERNAL_ERR - 3);
  CS_END_DATA           = (CS_EXTERNAL_ERR - 4);
  CS_END_RESULTS        = (CS_EXTERNAL_ERR - 5);
  CS_END_ITEM           = (CS_EXTERNAL_ERR - 6);

  CS_ROW_RESULT         = 4040;
  CS_CURSOR_RESULT      = 4041;
  CS_PARAM_RESULT       = 4042;
  CS_STATUS_RESULT      = 4043;
  CS_MSG_RESULT         = 4044;
  CS_COMPUTE_RESULT     = 4045;
  CS_CMD_DONE           = 4046;
  CS_CMD_SUCCEED        = 4047;
  
  CS_CANCEL_CURRENT     = 6000;
  CS_CANCEL_ALL         = 6001;

  CS_LANG_CMD           = 148;
  CS_RPC_CMD            = 149;
  CS_MSG_CMD            = 150;

  CS_SERVERMSG_CB       = 2;
  CS_CLIENTMSG_CB       = 3;

  CS_MESSAGE_CB         = 9119;
  CS_USERNAME           = 9100;
  CS_PASSWORD           = 9101;
  CS_APPNAME            = 9102;
  CS_HOSTNAME           = 9103;
  
  CS_FORCE_EXIT         = 300;
  CS_FORCE_CLOSE        = 301;

type
  CS_INT                = Integer;
  CS_RETCODE            = Integer;
  CS_BOOL               = Integer;
  CS_UINT               = Integer;
  CS_TINYINT            = Byte;
  CS_SMALLINT           = SmallInt;
  CS_CHAR               = PChar;
  CS_BINARY             = Byte;
  CS_BIT                = Byte;
  CS_REAL               = Single;
  CS_BYTE               = Byte;
  CS_TEXT               = Byte;
  CS_IMAGE              = Byte;
  CS_LONGCHAR           = Byte;
  CS_LONGBINARY         = Byte;
  CS_LONG               = LongInt;
  CS_VOIDDATA           = CS_INT;
  CS_USHORT             = Word;
  CS_FLOAT              = Double;
  CS_MSGNUM             = LongInt;

  CS_VOID               = Pointer;
  CS_CONTEXT            = Pointer;
  CS_LOCALES            = Pointer;
  CS_CONNECTION         = Pointer;
  CS_COMMAND            = Pointer;
  CS_IODESC             = Pointer;

  PCS_INT               = ^CS_INT;
  PCS_UINT              = ^CS_UINT;
  PCS_TINYINT           = ^CS_TINYINT;
  PCS_SMALLINT          = ^CS_SMALLINT;
  PCS_CHAR              = ^Char; //^CS_CHAR;
  PCS_BINARY            = ^CS_BINARY;
  PCS_BIT               = ^CS_BIT;
  PCS_REAL              = ^CS_REAL;
  PCS_BYTE              = ^CS_BYTE;
  PCS_TEXT              = ^CS_TEXT;
  PCS_IMAGE             = ^CS_IMAGE;
  PCS_LONGCHAR          = ^CS_LONGCHAR;
  PCS_LONGBINARY        = ^CS_LONGBINARY;
  PCS_LONG              = ^CS_LONG;
  PCS_USHORT            = ^CS_USHORT;

  PCS_COLUMN_DATA = ^CS_COLUMN_DATA;
  CS_COLUMN_DATA = record
    indicator   : PCS_SMALLINT; //CS_SMALLINT;
    value       : CS_CHAR; //CS_CHAR;
    valuelen    : PCS_INT; //CS_INT;
  end;

  PCS_DATAFMT = ^CS_DATAFMT;
  CS_DATAFMT = record
    name        : Array[0..CS_MAX_NAME-1] of Char; //CS_CHAR;
    namelen     : CS_INT;
    datatype    : CS_INT;
    format      : CS_INT;
    maxlength   : CS_INT;
    scale       : CS_INT;
    precision   : CS_INT;
    status      : CS_INT;
    count       : CS_INT;
    usertype    : CS_INT;
    locale      : Pointer;
  end;

  CS_SERVERMSG = record
    msgnumber   : CS_MSGNUM;
    state       : CS_INT;
    severity    : CS_INT;
    text        : Array[0..CS_MAX_MSG-1] of Char; //CS_CHAR;
    textlen     : CS_INT;
    svrname     : Array[0..CS_MAX_NAME-1] of Char;
    svrnlen     : CS_INT;
    proc        : Array[0..CS_MAX_NAME-1] of Char;
    proclen     : CS_INT;
    line        : CS_INT;
    status      : CS_INT;
    sqlstate    : Array[0..CS_SQLSTATE_SIZE-1] of CS_BYTE;
    sqlstatelen : CS_INT;
  end;


  CS_CLIENTMSG = record
    severity    : CS_INT;
    msgnumber   : CS_MSGNUM;
    msgstring   : Array[0..CS_MAX_MSG-1] of Char;
    msgstringlen: CS_INT;
    osnumber    : CS_INT;
    osstring    : Array[0..CS_MAX_MSG-1] of Char;
    osstringlen : CS_INT;
    status      : CS_INT;
    sqlstate    : Array[0..CS_SQLSTATE_SIZE-1] of CS_BYTE;
    sqlstatelen : CS_INT;
  end;

function CS_NUMBER  (N : CS_MSGNUM) : CS_MSGNUM;
function CS_ORIGIN  (O : CS_MSGNUM) : CS_MSGNUM;
function CS_SEVERITY(S : CS_MSGNUM) : CS_MSGNUM;

function ct_describe(
    cmd         : CS_COMMAND;
    item        : CS_INT;
    var datafmt : CS_DATAFMT): CS_RETCODE stdcall; // is a record

function ct_bind(
    cmd         : CS_COMMAND;
    item        : CS_INT;
    var datafmt : CS_DATAFMT; // is a record
    buf         : CS_VOID;
    outputlen   : PCS_INT;
    indicator   : PCS_SMALLINT): CS_RETCODE stdcall;

function ct_res_info(
    cmd         : CS_COMMAND;
    operation   : CS_INT;
    var buf     : CS_INT; //CS_VOID;
    buflen      : CS_INT;
    outlen      : PCS_INT): CS_RETCODE stdcall;

function ct_results(
    cmd             : CS_COMMAND;
    var result_type : CS_INT): CS_RETCODE stdcall;

function ct_send(cmd: CS_COMMAND): CS_RETCODE stdcall;

function ct_cancel(
    connection  : CS_CONNECTION;
    cmd         : CS_COMMAND;
    ctype       : CS_INT): CS_RETCODE stdcall;

function ct_command(
    cmd     : CS_COMMAND;
    ctype   : CS_INT;
    buf     : CS_CHAR; //CS_VOID;
    buflen  : CS_INT;
    option  : CS_INT): CS_RETCODE stdcall; 
    
function ct_fetch(
    cmd         : CS_COMMAND;
    ftype       : CS_INT;
    offset      : CS_INT;
    option      : CS_INT;
    var count   : CS_INT): CS_RETCODE stdcall;

function cs_ctx_alloc(
    version     : CS_INT; 
    var outptr  : CS_CONTEXT): CS_RETCODE stdcall; 

function cs_ctx_drop(context: CS_CONTEXT): CS_RETCODE stdcall;
 
function ct_init(
    context : CS_CONTEXT;
    version : CS_INT): CS_RETCODE stdcall;

function ct_callback(
    context     : CS_CONTEXT;
    connection  : CS_CONNECTION;
    action      : CS_INT;
    ctype       : CS_INT;
    func        : CS_VOID): CS_RETCODE stdcall;

function cs_config(
    context     : CS_CONTEXT;
    action      : CS_INT; 
    prop        : CS_INT; 
    buf         : CS_VOID;
    buflen      : CS_INT; 
    outlen      : PCS_INT): CS_RETCODE stdcall;

function ct_con_alloc(
    context         : CS_CONTEXT;
    var connection  : CS_CONNECTION): CS_RETCODE stdcall;

function ct_con_drop(
    connection  : CS_CONNECTION): CS_RETCODE stdcall; 

function ct_con_props(
    connection  : CS_CONNECTION;
    action      : CS_INT;
    aproperty   : CS_INT;
    buf         : CS_VOID;
    buflen      : CS_INT;
    outlen      : PCS_INT): CS_RETCODE stdcall;
    
function ct_connect(
    connection  : CS_CONNECTION;
    server_name : CS_CHAR;
    snamelen    : CS_INT): CS_RETCODE stdcall;

function ct_cmd_alloc(
    connection  : CS_CONNECTION;
    var cmdptr  : CS_COMMAND): CS_RETCODE stdcall;

function ct_cmd_drop(cmd: CS_COMMAND): CS_RETCODE stdcall;

function ct_cmd_props(
    cmd         : CS_COMMAND;
    action      : CS_INT;
    cproperty   : CS_INT;
    buf         : CS_VOID;
    buflen      : CS_INT;
    outlen      : PCS_INT): CS_RETCODE stdcall;

function ct_close(
    connection  : CS_CONNECTION;
    option      : CS_INT): CS_RETCODE stdcall;

function ct_exit(
    context : CS_CONTEXT;
    option  : CS_INT): CS_RETCODE stdcall;
    
implementation
function ct_con_props;      external 'libct.dll';
function ct_describe;       external 'libct.dll';
function ct_bind;           external 'libct.dll';
function ct_results;        external 'libct.dll';
function ct_res_info;       external 'libct.dll';
function ct_send;           external 'libct.dll';
function ct_fetch;          external 'libct.dll';
function ct_cancel;         external 'libct.dll';
function ct_command;        external 'libct.dll';
function cs_ctx_alloc;      external 'libcs.DLL';
function cs_ctx_drop;       external 'libcs.DLL';
function ct_init;           external 'libct.dll';
function ct_callback;       external 'libct.dll';
function cs_config;         external 'libcs.DLL';
function ct_con_alloc;      external 'libct.dll';
function ct_con_drop;       external 'libct.dll';
function ct_connect;        external 'libct.dll';
function ct_cmd_alloc;      external 'libct.dll';
function ct_cmd_drop;       external 'libct.dll';
function ct_cmd_props;      external 'libct.dll';
function ct_close;          external 'libct.dll';
function ct_exit;           external 'libct.dll';

function CS_ORIGIN(O : CS_MSGNUM) : CS_MSGNUM;
begin
   result := ((O shr 16) and $ff);
end;

function CS_SEVERITY(S : CS_MSGNUM) : CS_MSGNUM;
begin
   result := ((S shr 8) and $ff);
end;

function CS_NUMBER(N : CS_MSGNUM) : CS_MSGNUM;
begin
   result := (N and $ff);
end;

end.
